<?php
//fonction de convertion d'unité
function convert_bytes($val , $type_val , $type_wanted){
	$tab_val = array("o", "ko", "Mo", "Go", "To", "Po", "Eo"); 
	if (!(in_array($type_val, $tab_val) && in_array($type_wanted, $tab_val))) 
	return 0; 
	$tab = array_flip($tab_val); 
	$diff = $tab[$type_val] - $tab[$type_wanted]; 
	if ($diff > 0) 
	return ($val * pow(1024, $diff)); 
	if ($diff < 0) 
	return ($val / pow(1024, -$diff)); 
	return ($val); 
}
//fonction qui redimensionne une image d'un lien
require('../_admin/controls/create_miniatures.php');
//dossier de la galerie image par defaut
$params = mysqli_query($db, "SELECT id, nom_galerie, titre_galerie, vLargeur, vLongueur FROM $tgaleries WHERE selectionner=1");
$valeurs_params = mysqli_fetch_array($params, MYSQLI_BOTH);
$folderImages = $valeurs_params['nom_galerie'];
$path = '../userfiles/gphotos/'.$folderImages;

echo '<div id="titreAdmin">Ajout d\'une ou plusieurs image(s)</div>';
$nav = '<div><a class="button" href="index.php?fadmin=gd_galerie&amp;install=end">Galerie</a>
</div>
</div>';
$reussi = '<div id="contentAdmin">
<p>Le fichier a bien été uploadé. <strong>Si celui-ci existe déjà il n\'est pas réuploadé</strong>. Vous pouvez continuer en revenant sur la page de la galerie ou simplement choisir une autre fonctionnalité du CMS.</p>'.$nav.'</div>';
$erreur2='<div id="contentAdmin"><p class="txtnormal">Le type de fichier est invalide. Veuillez sélectionner un fichier de taille plus petite ou de type png, gif, jpeg, jpg ou zip !</p>'.$nav.'</div>';  
$erreur1='<div id="contentAdmin"><p class="txtnormal">Votre fichier dépasse la taille autorisée par votre serveur php. Si votre fichier est trop gros, modifier le fichier <strong>php.ini</strong> avec les valeurs suivantes :<br/>- Upload_max_filesize : 2Mo -> 20Mo<br/>
- Maximum execution time : 30 -> 120</p>'.$nav.'</div>';  

$fimg = @$_FILES['icone']['name'];      //Le nom original du fichier, comme sur le disque du visiteur (exemple : mon_icone.png).
$ftype = @$_FILES['icone']['type'];     //Le type du fichier. Par exemple, cela peut être « image/png ».
$fsize = @$_FILES['icone']['size'];     //La taille du fichier en octets.
$ftemp = @$_FILES['icone']['tmp_name']; //L'adresse vers le fichier uploadé dans le répertoire temporaire.
$ferr = @$_FILES['icone']['error']; 

$fichier=$filename.'/'.$fimg;
$extensions_valides = array( 'jpg' , 'jpeg' , 'gif' , 'png', 'zip' );
$extfile = substr( strrchr($fimg, '.')  ,1);
$allowed_types = array("image/bmp", "image/gif", "image/png", "image/jpeg", "image/jpg", "multipart/x-zip");
if(!in_array(@$_FILES['icone']['type'], $allowed_types)) { }

//dimension maximum des vignetes medium
$maxwidth = 800;
$maxheight = 600;

//recupère taille du dossier uploader
$fileImg =  filesize($fichier);
$sizeDossier = round(convert_bytes($fileSize,'o','Mo'),PHP_ROUND_HALF_EVEN);

//récupère dimension des images uploadées
$dim = getimagesize($fichier);

// teste le nom de fichier
if( preg_match('#[\x00-\x1F\x7F-\x9F/\\\\]#', $fimg) ) {
    echo 'Nom de fichier non valide';
}
//liste des images de la galerie
$dirImages = opendir($path);
while ($nomImage = readdir ($dirImages)) {
	if($nomImage != "." && $nomImage != "..") { $tabImages[] = $nomImage; }
}
closedir($dirImages);
//on verifie la taille du zip, si il est trop gros, egal null
if ($fimg == null) { echo $erreur2; 
} else if ($fsize == null || $fsize == 0) {
	echo $erreur1;
}

//on verifie le type de fichier
if(!empty($ftemp) && is_uploaded_file($ftemp)) {
	if(in_array($extfile, $extensions_valides)) {
		move_uploaded_file($ftemp, $filename.'/'.$fimg);
		if($extfile == 'zip') { 
			if ($fsize > 0) { 
				$archive = new PclZip($fichier); 
				if ($archive->extract(PCLZIP_OPT_PATH,$filename,PCLZIP_OPT_SET_CHMOD, 0775) == 0) {
					echo $erreur2;
				} else if(($list=$archive->listContent())==0) {
					die("Error : ".$archive->errorInfo(true));
				}
				for($i=0; $i<sizeof($list); $i++) {
					for(reset($list[$i]); $key = key($list[$i]); next($list[$i])) {
						//dossier source - image - largeur, longueur - dossier destination - prefixe
						create_imgmedium($path, $list[$i]['filename'], $valeurs_params[3], $valeurs_params[4]*($maxwidth/$valeurs_params[4]), '/medium/', "_");
						create_imgmin($path, $list[$i]['filename'], $valeurs_params[3], $valeurs_params[4], '/small/', "__");
					}
				}
			} else {
				echo $erreur1;
			}
		} else {
			//si pas de zip alors creation miniature individuelle
			create_imgmedium($path, $fimg, $valeurs_params[3], $valeurs_params[4]*($maxwidth/$valeurs_params[4]), '/medium/', "_"); 
			create_imgmin($path, $fimg, $valeurs_params[3], $valeurs_params[4], '/small/', "__"); 
			echo $reussi;
		}
		// effacement de l'archive zip
		if (mb_eregi('zip', $fichier)) {
			unlink($fichier); 
			echo $reussi;
		}
	} else {
		echo $erreur2;
	}
}
?>
