<?php
// chargement de la librairie pclzip
include("../_admin/pclzip_lib.php");

//on recupere le module
$activate = mysqli_query($db, "SELECT id, activer FROM $tmodules WHERE nom_module='gd_galerie'");
$module_activer = mysqli_fetch_array($activate, MYSQLI_NUM);

//selection des galeries
$nomGalerie = mysqli_query($db, "SELECT id, nom_galerie, titre_galerie, selectionner FROM $tgaleries");

//selection des parametres de la galerie
$galdefaut = mysqli_query($db, "SELECT id, nom_galerie, titre_galerie, nbPerPage, nbColonnes, vLargeur, vLongueur, txtIntro, selectionner, typegalerie FROM $tgaleries WHERE selectionner=1");
$galselect = mysqli_fetch_array($galdefaut, MYSQLI_BOTH);
$nom_galerie = $galselect['nom_galerie'];

//selection des menus
$tmenu = mysqli_query($db, "SELECT id, catPage, nomPage, titrePage, headermenu FROM $tposts");
$title = mysqli_fetch_array($tmenu);

//selection du mode du module
$interactif = mysqli_query($db, "SELECT retrieve FROM $tmodules WHERE nom_module='gd_galerie'");
$module_reactif = mysqli_fetch_array($interactif, MYSQLI_BOTH);

//selection des descriptions de la galerie
$params_desc = mysqli_query($db, "SELECT id, nom_img, lien, description, valeur FROM $tdescgals");

// repertoires des photos
$folderPhotos = '../userfiles/gphotos/'.$nom_galerie.'/';

//Créer un dossier 'fichiers/'
if (file_exists($folderPhotos)) {
} else {
	mkdir($folderPhotos, 0777, true);
}

echo '<div class="titreAdmin">1. Mise en page de la galerie photos : <span class="pcolor">'.strtoupper($nom_galerie).'</span> 
<p class="txtnormal">Ce formulaire vous aidera à créer une galerie photos. Celle-ci est composée d\'un nombre de paramètres pour la mise en forme de la galerie.<br/>
Vous pouvez créer plusieurs galeries photos liées à un lien ou un bouton n\'importe ou sur le site.<br/><br/>
Comment préparer la galerie d\'images :<br/>
- Dans le menu du tableau de bord, Cliquer sur le bouton <strong>PHPinfo</strong> et vérifier que la <strong>librairie GD</strong> est en position <strong>enabled</strong><br/>
- Uploader des images de grande dimensions, de préférence avec les mêmes dimensions. <br/>
- Celles-ci sont automatiquement <strong>redimensionnées</strong> en deux formats <strong>moyen</strong> et <strong>vignette</strong> .<br/>
- Elles sont automatiquement copiées dans les dossiers <strong>userfiles/gphotos/'.$galselect[1].'/medium</strong> et <strong>userfiles/gphotos/'.$galselect[1].'/small</strong>.</p>
<p class"pcolor">La galerie possède deux façons de s\'afficher :<br/>- Via la base de données, ou il faudra ajouter une description sur chaque image.<br/>- Via les fichiers du dossier <strong>userfiles/gphotos/'.$galselect[1].'</strong>.</p></div>';
?>	
<div class="contentAdmin">
<form method="post" action="index.php?fadmin=update_galerie&amp;install=end">
  <table class="form-table">
	 <tr>
		<td>Activation du module :</td>
		<td><?php if($module_activer[1]!=0) {?><input name="texte_activer[]" type="checkbox" checked="checked" class="bloc" value="1" />
	  <?php } else { ?> <input name="texte_activer[]" type="checkbox" class="bloc" value="" /><?php } ?>
	  </td>
	</tr>
	<tr>
		<td>Module interactif :</td>
		<td><?php if($module_reactif[0]!=0) {?><input name="texte_reactif[]" type="checkbox" checked="checked" class="bloc" value="1" />
	  <?php } else { ?> <input name="texte_reactif[]" type="checkbox" class="bloc" value="" /><?php } ?>
	  Ajoute un lien de téléchargement du fichier lié à l'image.</td>
	</tr>
	<tr>
		<td>Type de galerie :</td>
		<td><?php if($galselect[9]!=0) {?><input name="mode_galerie[]" type="checkbox" checked="checked" class="bloc" value="1" />
	  <?php } else { ?> <input name="mode_galerie[]" type="checkbox" class="bloc" value="" /><?php } ?>
	  Pour afficher la galerie via la bdd <strong>cocher la case</strong>.</td>
	</tr>
	<tr>
		<td style="width:170px">Nom/Lien de la galerie :</td>
		<td><input name="nom_galerie" type="text" class="bloc" size="20" maxlength="20" value="<?php if($galselect['nom_galerie']==$nom_galerie) { echo $galselect['nom_galerie']; } ?>" />
		Saisir un nom pour créer une nouvelle galerie (20 caractères max).</td>
    </tr>
	<tr>
		<td style="width:170px">Titre de la page :</td>
		<td><input name="titre_galerie" type="text" class="bloc" size="20" maxlength="100" value="<?php echo $galselect['titre_galerie']; ?>" />
		Saisir un titre de page <strong>uniquement si celui-ci n'est pas inclus</strong> dans le menu de l'entête.</td>
    </tr>
	<tr>
		<td style="width:170px"><span class="pcolor">Liste des galeries</span> :</td>
		<td><select name="liste_galerie">
		<option></option>
		<?php mysqli_data_seek($nomGalerie, 0);
		while ($valeurs_galerie = mysqli_fetch_array($nomGalerie, MYSQLI_NUM)) { ?>
		<option><?php echo $valeurs_galerie[1]; ?></option>	<?php } ?>		
		</select>
		<?php if ($galselect['selectionner']==1) { ?>
		<input type="hidden" name="selectionner" value="<?php echo $galselect['id']; ?>" checked="checked" />
		<?php } else { ?>
		<input type="hidden" name="selectionner" value="<?php echo $galselect['id']; ?>" />
		<?php } ?>
		<span class="pcolor">Choisir la <strong>galerie que l'on veut modifier</strong>. Revenir ensuite sur ce formulaire pour modifier les valeurs de la galerie sélectionnée.</span></td>
	</tr> 
	<tr>
		<td style="width:170px; vertical-align:top">Texte d'intro :</td>
		<td><textarea name="text_intro" rows="4" cols="58"><?php echo $galselect['txtIntro']; ?></textarea>
		<br/>Saisir un texte d'introduction de la galerie.</td>
    </tr>
	<tr>
      <td style="width:170px">Largeur de la vignette :</td>
      <td>
	  <input name="Lvignette" type="text" class="bloc" size="3" maxlength="3" value="<?php echo $galselect['vLongueur'] ?>" required />
	  </td>
    </tr>
    <tr>
      <td>Hauteur de la vignette :</td>
      <td><input name="Hvignette" type="text" class="bloc" size="3" maxlength="3" value="<?php echo $galselect['vLargeur'] ?>" required /></td>
    </tr>
    <tr>
      <td>Nb vignettes par page :</td>
      <td><input name="nbPerPage" type="text" class="bloc" size="3" maxlength="2" value="<?php echo $galselect['nbPerPage'] ?>" /> 
	  </td>
    </tr>
    <tr>
      <td>Nombre de colonnes :</td>
      <td><input name="nbColonnes" type="text" class="bloc" size="3" maxlength="1" value="<?php echo $galselect['nbColonnes'] ?>" />
	  <?php if ($module_reactif[0]==0) { ?> Pour une galerie avec description, ne pas dépasser les 2 colonnes.<?php } ?>
	  </td>
    </tr>
  </table>
  <p><input type="submit" class="button" name="envoyer_galerie" value="Valider" />
  <a class="button" href="index.php?fadmin=gestion_modules">Retour</a></p>
</form>
</div>
<div class="titreAdmin">2. Ajouter une ou plusieurs image(s) à la <span class="red">galerie sélectionnée</span>
<p>Vous pouvez ajouter image par image ou plusieurs images compressées au format zip (désactiver la <strong>sécurité du contenu</strong> dans les options avant l'upload). Dans les deux cas il faut que le poids du fichier soit inférieur <strong>2Mo</strong> pour un hébergeur gratuit.<br/> Sinon, il faut modifier les valeurs du fichier php.ini de votre hébergeur, en fonction de la taille des fichiers que l'on veut ajouter. Exemple ci-dessous :<br/>
	- Upload_max_filesize : 2Mo -> 20Mo<br/>
	- Maximum execution time : 30 -> 120</p></div>
<div class="contentAdmin">
<form method="post" enctype="multipart/form-data" action="index.php?fadmin=update_images&amp;install=end">
	<table class="form-table">
	  <tr>
	    <td style="width:160px">Ajouter un fichier :</td>
	    <td><input name="icone" type="file" class="btn_parcourir" id="icone" /></td>
	  </tr>

	</table>
	<input name="Ajouter" type="submit" class="button" id="ajouter" value="Ajouter" />
	<a class="button" href="index.php?fadmin=gestion_modules&amp;install=end">Retour</a>
	<input type="hidden" name="MAX_FILE_SIZE" value="14000000" /></p>
</form>
</div>
<?php
$titre = '3. Ajouter une description pour chaque photo de la galerie';
echo '<div class="titreAdmin">', $titre ,'
<p>La saisie est limitée à deux lignes maximum, afin d\'avoir une lisibilité optimale sur l\'affichage de la galerie.
En mode interactif, le nom des fichiers doit être saisi sans l\'extension et au format zip. <br/>Ceux-ci doivent être copiés dans le dossier <strong>/userfiles/gphotos/'.$nom_galerie.'</strong>.</p></div>';
echo '<div class="contentAdmin">';
// ouverture du repertoire
$repertoire = opendir($folderPhotos) or die('Erreur');
while($fichier = @readdir($repertoire)) {
	// si le fichier est un repertoire on ouvre
	if(is_dir($folderPhotos.'/'.$fichier) && $fichier != '.' && $fichier != '..') {
		//Scanrepertoire($folderPhotos.'/'.$entree);         
	} else {
		if($dir = !is_dir($fichier) && $fichier != '.' && $fichier != '..' && $fichier != 'index.php?fadmin=galerie') {
			$tab_fichier[] = $fichier;
		}
	}
}
if (isset($tab_fichier)){ usort($tab_fichier,"strnatcmp"); }
closedir($repertoire);

if (isset($tab_fichier)) { $nbfichiers = count($tab_fichier); } else { $nbfichiers=0; }
?><form method="post" enctype="multipart/form-data" action="index.php?fadmin=update_description&amp;install=end"> <?php
if (isset($tab_fichier) && count($tab_fichier) > 0) {
	$nbfichiers = count($tab_fichier);
	if ($nbfichiers != 0) {
		?><div class="tabRessource">
			<div class="gtitrecell1">N°</div>
			<div class="gtitrecell2">Photos</div>
			<div class="gtitrecell3">Lien</div>
			<div class="gtitrecell4">Description</div>
			<div class="gtitrecell3">Valeur</div>
			<?php 
			$tabphotos = array();
			while ($valeurs_desc = mysqli_fetch_row($params_desc)) {
					$tabphotos [$valeurs_desc[1]] = Array(
						"lien" => $valeurs_desc[2],
						"description" => $valeurs_desc[3],
						"valeur" => $valeurs_desc[4]
					);
				} ?> <input type="hidden" name="nbimg" value="<?php echo $nbfichiers; ?>"/>
			<?php for ($i=0; $i<$nbfichiers; $i++){ $file = $tab_fichier[$i]; $lienfile = explode ('.', $file); ?>
				<input type="hidden" name="nomimg<?php echo $i; ?>" value="<?php echo $file; ?>"/>
				<div class="gcell1"><?php echo $i+1; ?></div>
				<div class="gcell2"><?php echo $file; ?></div>
				<?php if(array_key_exists($file,$tabphotos)) { ?>
				<textarea class="gcell3" name="txtlieu<?php echo $i; ?>" rows="2" cols="10"><?php echo $lienfile[0].'.zip'; ?></textarea>
				<textarea class="gcell4" name="txtdesc<?php echo $i; ?>" rows="2" cols="40"><?php echo $tabphotos[$file]['description']; ?></textarea>
				<textarea class="gcell3" name="txtprix<?php echo $i; ?>" rows="2" cols="10"><?php echo $tabphotos[$file]['valeur']; ?></textarea>
			<?php } else {  ?>
				<textarea class="gcell3" name="txtlieu<?php echo $i; ?>" rows="2" cols="10"></textarea>
				<textarea class="gcell4" name="txtdesc<?php echo $i; ?>" rows="2" cols="40"></textarea>
				<textarea class="gcell3" name="txtprix<?php echo $i; ?>" rows="2" cols="10"></textarea>
			<?php } } ?>
		</div>
	<?php } ?>
	<p><input name="envoyer_desc" type="submit" class="button" id="envoi" value="Valider" />
	<a class="button" href="index.php?fadmin=gestion_modules&amp;install=end">Retour</a></p>
<?php } else { 
	?><p>Aucune image trouvée dans le dossier</p>
	<a class="button" href="index.php?fadmin=gestion_modules&amp;install=end">Retour</a></p>
<?php } ?>	
	</form>
</div> 
