<?php
include_once ('_admin/date_to_french.php');
/* Configure le limiteur de cache à 'private' */
session_cache_limiter('private');
$cache_limiter = session_cache_limiter();
/* Configure le délai d'expiration à 1 minute */
session_cache_expire(1);
$cache_expire = session_cache_expire();

session_start();

if (!isset($_GET['finstall'])) {
	$finstall='create_config'; 
} else {
	$finstall=$_GET['finstall']; 
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>CMS GDidées - Administration du site</title>
<link rel="stylesheet" href="_include/styles/install.css" type="text/css" />
<link rel="stylesheet" href="_include/styles/admin.css" type="text/css" />
</head>
<body>
<div id="container">
<?php 
if (isset($_GET['finstall'])) {
	echo '<div id="logo"><img alt="GDidees" src="_include/images/logo-cms.png" /></div>
	<div id="datelogin">Nous sommes le '.mb_convert_encoding(dateToFrench("now", "l j F Y - H:i"), 'UTF-8') .'</div>';
}
	echo '<div id="content1">
	<div id="contentInstall">';
	switch($finstall) {
		////////////////////////////// pages d'install ////////////////////////////
		case 'create_config':include ('_install/create_config.php');break;
		case 'create_table':include ('_install/create_table.php');break;
		case 'create_template':include ('_install/create_template.php');break;
		case 'create_admin':include ('_install/create_admin.php');break;
		case 'create_site':include ('_install/create_site.php');break;
		case 'create_connexion':include ('_install/create_connexion.php');break;
		////////////////////////////// pages d'admin /////////////////////////////
		case 'index_admin':include ('_admin/index.php'); break;
	}
	if (isset($_GET['finstall'])) {
		echo '</div><div id="footer">Copyright <a href="https://www.gdidees.eu">www.gdidees.eu</a></div>';
	}
	echo'</div>
</div>';
?> 
</body>
</html>